<template>
  <v-container>
    <v-row justify="center">
      <v-col cols="12" md="9">
        <lesson-content-purchase
          v-if="lesson && course"
          :lesson="lesson"
          :course="course"
          :purchases="purchases"
        />
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { LessonContent as LessonContentEntity } from '@/domain/entity/lesson/LessonContent';
import LessonContentPurchase from '@/components/lesson/content/LessonContentPurchase.vue';
import { PurchaseCourse } from '@/domain/entity/purchase/course/PurchaseCourse';
import { AuthInfoResponse } from '@/domain/response/auth/info/AuthInfoResponse';
import { Course } from '@/domain/entity/course/Course';

@Component({
  components: {
    LessonContentPurchase
  }
})
export default class LessonContentView extends Vue {
  private get id(): string {
    return this.$route.params.id;
  }

  private get lesson(): LessonContentEntity | null {
    return this.$store.getters['lessonContent/lesson'];
  }

  private get course(): Course | null {
    return this.$store.getters['courses/course'];
  }

  private get purchases(): PurchaseCourse[] {
    return this.$store.getters['purchasesCourse/items'];
  }

  private async mounted(): Promise<void> {
    await this.$store.dispatch('lessonContent/fetch', this.id);
    const info: AuthInfoResponse | null = await this.$store.getters[
      'auth/info'
    ];
    if (!info) {
      console.log('info is null');
    } else {
      await this.$store.dispatch('purchasesCourse/fetch', info.id);
    }
    if (!this.lesson) {
      console.log('lesson is null');
    } else {
      await this.$store.dispatch('courses/fetchCourse', this.lesson.courseId);
    }
  }
}
</script>

<style scoped></style>
